# importing modules
import sys as sys
import os 
import numpy

# Getting the name of the directory where this file is present.
current = os.path.dirname(os.path.realpath(__file__))  # src
# Getting the parent directory name where the current directory is present.
parent = os.path.dirname(current) # Simulation
# Getting the grandparent directory name
gparent = os.path.dirname(parent) # RecruitmentSynchronization_SMCs
# The path where the simExp.py is saved
mpath = gparent + '\\cellLib\\Scripts'
# appending a path
sys.path.append(mpath)
import simExp
# The simulation .sedml file
simfile = gparent+'\\Experiments\\SMC_KCl_noise.sedml'
# Set the parameters for simulation
start, ending, pointInterval = 0, 150, 0.01

savefiles=[parent+'\\simulatedData\\simFig3']
indexStart = 0
indexEnd = int(ending/pointInterval) + 1 
varSet = {'free_para/E':{'constants':0.01},'free_para/J_PLCagonisti':{'constants':0.078}}
varLoop = {'clamp_para/X_Test':{'constants':numpy.array([5])}}
varSave = {'t':{'voi':False},'output/c_i':{'states':False},'output/s_i':{'states':False},'output/v_i':{'states':False},'output/I_i':{'states':False},'output/w_i':{'states':False}}
simExp.simExp(simfile, savefiles,start, ending, pointInterval,indexStart,indexEnd,varSet,varLoop,varSave)

